Fix generation of pdf graphs
[can-benchmark.git] / gw-tests / lib.sh
1 set -e
2
3 COUNT=10000
4
5 OPT_TRAFFIC=oneatatime
6 OPT_LOAD=none
7
8 error() {
9     echo $1 >&2
10     exit 1
11 }
12
13 while [ $# -gt 0 ]; do
14     case "$1" in
15         -P|--no-plot) OPT_PLOT_DISABLE=1; shift;;
16         -p|--plot) OPT_PLOT_ONLY=1; shift;;
17         -X|--no-x11-plot) OPT_NO_X11=1; shift;;
18         -t) case "$2" in
19                 all|flood|50|oneatatime) OPT_TRAFFIC=$2;;
20                 *) error "Unknown traffic specification: $2";;
21             esac;
22             shift 2;;
23         -l) case "$2" in
24                 all|none|cpu|eth|can) OPT_LOAD=$2;;
25                 *) error "Unknown load specification: $2";;
26             esac;
27             shift 2;;
28     esac
29 done
30
31 PATH=$PWD/../_compiled/bin/:$PATH
32
33 sshgw() {
34     local socket="$HOME/.ssh/cangw-connection"
35
36     if [[ ! -S $socket ]] || ! ssh -x -a -S $socket root@192.168.2.3 true; then
37         # Create master connection to speed up subsequenct command.
38         ssh -N -f -M -S $socket root@192.168.2.3 >/dev/null 2>&1
39     fi
40     ssh -x -a -S $socket root@192.168.2.3 "$@"
41 }
42
43 cleanupgw() {
44     sshgw 'cangw -F'
45 }
46
47 _plot() {
48     local testname=`basename $0 .sh`
49
50     plot_cmds | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n{\/*0.75 (GW kernel $kvers, Traffic $traffic, Load $load)}\"/" > plot.gp
51     if [[ ! -s plot.gp ]]; then return; fi
52     if [ -z "$OPT_NO_X11" ]; then
53         echo "set terminal x11 enhanced; $(< plot.gp)" | gnuplot -persist
54     fi
55     I=''
56     echo "set terminal pdfcairo solid color enhanced; set output \"${testname}$I.pdf\";" \
57         "$(< plot.gp)" | gnuplot
58     echo 'set terminal pngcairo color enhanced size 750,525 font ",10" ;' \
59         "$(< plot.gp)" | gnuplot > ${testname}$I.png
60     mkdir -p thumb
61     convert -resize 150x105 -gamma 0.5 -quality 90 -type Palette -depth 8 ${testname}$I.png thumb/${testname}$I.png
62 #     echo 'set terminal pngcairo color enhanced size 150,105 font ",1";' \
63 #       "$(< plot.gp)" | gnuplot > thumb/${testname}$I.png
64
65 }
66
67 echo_plot() {
68     plot=$1
69     [[ "$_plot_separator" ]] && echo ", \\"
70     _plot_separator=t
71     echo -n "    " $plot
72 }
73
74 traffic_and_length() {
75     local opts
76     case $traffic in
77         flood) opts='';;
78         50)        opts="-p $((2*(44+$1*8)))";;
79         oneatatime)        opts="-o";;
80         *) error "Unknown traffic specification: $traffic"
81     esac
82     echo $opts -l $1
83 }
84
85 start_load() {
86     case $load in
87         none) ;;
88         cpu) sshgw 'hackbench -g 3 -l 10000' & loadpid=$!;;
89         eth) ping -f -s 60000 -q 192.168.2.3 & loadpid=$!;; # TODO: Generate eth load from another computer
90         can) latester -q -d can1 -i 0x7ff & loadpid=$!;;
91         *) error "Unknown load specification: $load"
92     esac
93 }
94
95 kill_load() {
96     case $load in
97         none) ;;
98         cpu) kill $loadpid; sshgw "killall -q hackbench || :";;
99         eth) kill $loadpid;;
100         can) kill $loadpid;;
101         *) error "Unknown load specification: $load"
102     esac
103 }
104
105 _measure() {
106     # Remove data from the last measurement
107     rm -rf *
108     # Kill load generators left possibly from the past runs
109     killall -q ping || :
110     killall -q latester || :
111     sshgw 'killall -q hackbench || :'
112     # Set can interfaces up
113     sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
114     # Delete all vcan interfaces
115     sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
116     # Reset priorities
117     sshgw 'if pid=`pidof irq/145-can0`; then chrt -p -f 50 $pid > /dev/null; fi'
118     sshgw 'if pid=`pidof irq/146-can1`; then chrt -p -f 50 $pid > /dev/null; fi'
119     sshgw 'if pid=`pidof sirq-net-rx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
120     sshgw 'if pid=`pidof sirq-net-tx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
121     # Set the length of qdisc queue to avoid ENOBUFS errors
122     ifconfig can0 txqueuelen 200
123     ifconfig can1 txqueuelen 200
124     cleanupgw
125
126     type prepare >/dev/null 2>&1 && prepare || :
127     start_load
128     main
129     kill_load
130
131     # Create a plot script at the end to signalize that the
132     # measurement was successfully finished
133     cat > plot.sh <<-EOF
134         #!/bin/bash
135         export kvers=$kvers
136         export hostkvers=$hostkvers
137         export traffic=$traffic
138         export load=$load
139         cd \$(dirname \$0)/$(dirname $script)
140         exec ./$(basename $script) --plot "\$@"
141         EOF
142     chmod +x plot.sh
143 }
144
145
146 _run() {
147     if [[ $OPT_TRAFFIC = all ]]
148     then traffics="flood 50 oneatatime"
149     else traffics=${traffic:-$OPT_TRAFFIC}
150     fi
151     if [[ $OPT_LOAD = all ]]
152     then loads="none cpu eth" # TODO: can
153     else loads=${load:-$OPT_LOAD}
154     fi
155     hostkvers=${hostkvers:-host-$(uname -r)}
156     kvers=${kvers:-$(sshgw uname -r)}
157     test=$(basename $0 .sh)
158     for load in $loads; do
159     for traffic in $traffics; do
160         dir="results/$hostkvers/$kvers/$traffic/$load/$test"
161         mkdir -p $dir
162         script=$(echo $dir | sed -e 's/[^/]*/../g')/${test}.sh
163         cd $dir
164         if [[ ! "$OPT_PLOT_ONLY" ]]; then
165             echo "Working directory: $dir"
166             _measure
167         fi
168         if [[ ! "$OPT_PLOT_DISABLE" ]]; then
169             _plot
170         fi
171         cd - > /dev/null
172     done
173     done
174 }
175
176 test_end() {
177     test_end_called=t
178     exit_ok=
179     _run
180     exit_ok=t
181 }
182
183 _myexit() {
184     code=$?
185     cmd=$BASH_COMMAND
186     if [[ ! "$test_end_called" ]]; then
187         test_end_called=t
188         error "bug in the test script: No test_end called"
189     fi
190     if ! test -n "$exit_ok"; then
191         error "FATAL: Command '$cmd' exit with code $code"
192     fi
193 }
194
195 trap '_myexit' EXIT